module Aufgabe34b (bewerte) where

import Set
import Monad (guard)

import Grammatik
import Ableitung
import Eindeutig
import Wrong
import Right
import Zeige
import Typen
import Vergleiche

original = Grammatik
	{ terminale = "xy+*()"
	, nichtterminale = "E"
	, startsymbol = 'E'
	, regeln = [ ("E", rechts)
		   | rechts <- [ "x", "y", "E+E", "E*E", "(E)" ]
		   ]
	}


schranke = 8 :: Int

l = erzeugte_sprache (Just schranke) original


bewerte :: Grammatik -> IO ()
bewerte g = do

    zeige (Just schranke) g
 
    case typ2 g of
	 Left  msg -> do putStrLn msg
			 wrong
	 Right msg -> do 
    putStrLn msg

    putStrLn $ "\nIch untersuche jetzt, ob Ihre Grammatik mehrdeutig ist,"
    putStrLn $ "durch Betrachtung aller Ableitungen von Wortformen der Lnge <= " ++ show schranke ++ ".\n"

    case eindeutig (Just schranke) g of
        Left msg -> do putStrLn msg
		       wrong
	Right msg -> do
    putStrLn msg


    vergleiche0 schranke (mkSet l) schranke g



    
    
    
