module Aufgabe43 where

import NPDA
import NPDATest
import Akzeptieren

import Wort
import Random

yes = do
    l <- randomRIO (2,10)
    if odd l then yes else do
       let h = l `div` 2
       u <- someIO "ab" (h-1)
       v <- someIO "ab" (h-1)
       return $ u ++ "a" ++ v ++ "b"

no = do
    l <- randomRIO (0, 10)
    let h = l `div` 2 - 1
    w <- someIO "ab" l    
    if l == 0 || odd l || w !! h /= 'a' || w !! (2 * h + 1) /= 'b'
       then return w
       else no

pos = sequence . take 20 . repeat $ yes
neg = sequence . take 20 . repeat $ no

bewerte student = do
    putStrLn $ unlines
        [ "Ich bin der automatische Korrektor fr Aufgabe IV.3."
	, ""
	, "Die Sprache { u a w b  |  u,w in {a,b}* und |u| = |w| }"
	, "soll durch einen Kellerautomaten durch leeren Stack akzeptiert werden."
	
	, "Siehe auch http://www.informatik.uni-leipzig.de/~joe/edu/ws00/auspra/autotool/pda.html"
	, ""
	]
    p <- pos
    n <- neg
    testNPDA 1000 akzeptierend_mit_leerem_keller p n student
