module Labelled where

import Next
import Set

data Labelled a b = Labelled { contents :: a
			     , tag :: b
			     }
     deriving (Eq, Ord)

instance (Show a, Show b) => Show (Labelled a b) where
    show l = show (tag l) ++ ":" ++ show (contents l)

class Label b where
    label :: [b] -> b

-- nicht effizient (Cache fehlt) aber korrekt

build :: (Next a, Label b) => a -> Labelled a b
build x = 
    let xs = map build $ next x
	l  = label $  map tag xs
    in	Labelled { contents = x, tag = l }

instance (Next a, Label b) => Next (Labelled a b) where
    next x = map build  $ next $ contents x
	


