module Nimber where

import Next
import Labelled
import Grundy
import PN
import Sum

data Nimber = Nimber Int
     deriving ( Eq, Ord )

instance Show Nimber where
    show (Nimber 0) = "0"
    show (Nimber 1) = "*"
    show (Nimber n) = "*" ++ show n

instance Next Nimber where
    next (Nimber x) = do
	 x' <- [ 0 .. x - 1 ]
	 return $ Nimber x'

plus fname x y 
    = paint fname 
    $ Sum (Nimber x, Nimber y)

pnplus fname x y 
      = paint fname 
      $ ( build (Sum (Nimber x, Nimber y)) :: Labelled (Sum Nimber Nimber) PN)


