-- nur zum konvertieren von String nach [String] und dann autofahren3
autofahren4 :: String -> [Regel] -> Graph(String)
autofahren4 str reg = autofahren3 [str] reg

-- rekursiver Aufbau der Funktion -> Aufruf der Regelanwendungen
autofahren3 :: [String] -> [Regel] -> Graph (String)
autofahren3 [] reg = Graph { knoten = mkSet [],kanten = mkSet []}
autofahren3 (s:str) reg = graphToGraph 
	(autofahren3 ((str) ++ (mr_use s reg)) reg )
	(autofahren2 s reg (mr_use s reg))
	(s:str)

-- Addieren zweier Graphen und hinzufgen des ersten Knotens (Prg-Aufruf)
graphToGraph :: Graph(String) -> Graph(String) -> [String] -> Graph(String)
graphToGraph graph1 graph2 str= Graph{
            knoten = mkSet ((knotenliste graph1) ++ (knotenliste graph2) ++ str),
 	    kanten = mkSet ((kantenliste graph1) ++ (kantenliste graph2))}

-- wei nicht mehr wozu, aber immerhin funktioniert es
autofahren2 :: String -> [Regel] -> [String] -> Graph(String)
autofahren2 str reg [] = Graph { knoten = mkSet [],kanten = mkSet []}
autofahren2 str reg (c:cx) = addToGraph (autofahren2 str reg cx) str c

-- fgt zum Graphen noch die Kante (str,x) hinzu	
addToGraph :: Graph (String) -> String -> String -> Graph (String)
addToGraph graph str x = Graph{knoten = mkSet ((knotenliste graph) ++ [x]),
			kanten = mkSet ((kantenliste graph) ++ [kante str x])}

-- | mr_use = more_rule_usage
-- Eingabe x y 
-- mit x = String 
-- und y = Regelmenge
-- Ausgabe = Menge aller aus der Eingabe erzeugbaren Wrter
mr_use :: String -> [Regel] -> [String]
mr_use str (r:rest) 
   | length((r:rest))>=2 = r_use str r ++ mr_use str rest
   | otherwise = r_use str r

-- | r_use = rule_usage
-- Eingabe x y 
-- mit x = String 
-- und y = einzeln Regel
-- Ausgabe = Menge aller aus der Eingabe erzeugbaren Wrter
r_use :: String -> Regel -> [String]
r_use str reg = do
   x <- (cut_list_vor str)
   y <- (cut_list_bac str)
   guard ( (y ++ x) == str )
   guard ( prefix x (from reg) )
   return $ (y ++ to reg ++ (drop (length (from reg)) x))

-- | cut_list_vor:
-- liefert die Liste aller Wrter, die entstehen,
-- wenn vom Wortanfang aus zeichenweise abgeschnitten
-- wird. Bsp: "list" -> ["list", "ist", "st", "t", ""]
cut_list_vor :: String -> [String]
cut_list_vor []  = [""]
cut_list_vor str = [str] ++ cut_list_vor(tail str)

-- | cut_list_bac:
-- liefert die Liste aller Wrter, die entstehen,
-- wenn vom Wortende aus zeichenweise abgeschnitten
-- wird. Bsp: "list" -> ["list", "lis", "li", "l", ""]
cut_list_bac :: String -> [String]
cut_list_bac []  = [""]
cut_list_bac str = cut_list_bac(take(length(str)-1)str) ++ [str]
-- cut_list_bac str = cut_list_bac(reverse(tail(reverse(str))))

-- | Prfix:
-- Parameter 1 = String zum darin suchen
-- Parameter 2 = zu testender Anfangsstring
-- Rckgabe == True, wenn Prfix oder ganzes Wort bereinstimmen
prefix :: String -> String -> Bool
prefix [] [] = True
prefix [] b  = False
prefix a  [] = True
prefix (s:str) (p:pre) = case (s==p) of
   True -> prefix str pre
   False -> False

regeln = [ Regel { from = "01", to = "10" }
	 , Regel { from = "1" , to  = "2" }
	 ]

-- autofahren :: [String] -> [Regel] -> Graph (String)
-- autofahren [] reg = Graph { knoten = mkSet [],kanten = mkSet []}
-- autofahren (s:str) reg = graphToGraph 
--	(autofahren ((str) ++ (regelanwendung s reg)) reg )
--	(autofahren2 s reg (regelanwendung s reg))
--	([s]++str)

-- leerer Graph:
-- graph1 = Graph { knoten = mkSet [] 
--	    ,kanten = mkSet []}
-- regelanwendung :: String -> [Regel] -> [String]
-- regelanwendung str reg = do
--         z <- (cut_list_vor str)    
--         x <- (cut_list_bac str)    
--         r <- (reg)
--         guard ((z ++ x)== str)     
--         guard (prefix x (from r))  
-- 	return $ (z ++ (to r) ++ (drop (length (from r)) x))
--        return $ z ++ (to r) ++ (drop (length (from r)) x)
