module Sum where

import Next

data Sum a b = Sum (a, b)
     deriving (Eq, Ord)

instance (Show a, Show b) => Show (Sum a b) where
    show (Sum (x, y)) = show x ++ "+" ++ show y

instance (Next a, Next b) => Next (Sum a b) where
    next (Sum (x, y)) 
        =  do x' <- next x; return $ Sum (x', y)
	++ do y' <- next y; return $ Sum (x, y')
        
