-- $Id: Manager.hs,v 1.1.1.1 2002/05/24 10:46:45 challenger Exp $

module Main where

-- holt Optionen von Kommandozeile und startet bei Erfolg und Wunsch wirklich

-- erstes argument: absender
-- zweites argument: subject (d.h. name der aufgabe)
-- weitere argumente werden ignoriert
-- stdin : inhalt der mail

-- $Log: Manager.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:45  challenger
-- start
--
-- Revision 1.1  2001/11/22 10:41:16  mrahn
-- - Kommandozeile verarbeiten
--

import Settings
import GetOpt
import System
import Run

version = "autotool manager, $Date: 2002/05/24 10:46:45 $"
foot = unlines $ 
       [ ""
       , "mainly written by Johannes Waldmann <joe@informatik.uni-leipzig.de>"
       , "with contribs by Mirko Rahn <mai99dla@studserv.uni-leipzig.de>"
       ]

main = do
       args <- getArgs

       case getOpt Permute options args of

        (o,n,[]) 
         | Version `elem` o      -> putStrLn version
         | length n < 2          -> error ["sender or excercise missed\n"]
         | ShowSettings `elem` o -> print $ mkSettings o n  
         | otherwise             -> run $ mkSettings o n

        (_,_,errs)               -> error errs

       where 
        error msg = putStr $ concat msg ++ usageInfo header options ++ foot
        header = "\nUsage: autotool [OPTION...] sender excercise"
