-- $Header: /home/joe/scratch/challenger/autotool/bin/Note.hs,v 1.1.1.1 2002/05/24 10:46:45 challenger Exp $

module Note where

-- $Log: Note.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:45  challenger
-- start
--
-- Revision 1.4  2001/11/22 10:41:16  mrahn
-- - Kommandozeile verarbeiten
--
-- Revision 1.3  2001/11/21 17:37:06  mrahn
-- - Util.hs hostet mehrfach benutztes Zeug
-- - Laufzeit mit in LOG
-- - Scorer/Statistik robuster, Kosmetik
--

import Settings
import Util

import Posix

note :: Settings -> String -> IO ()
note set = note_to (logfile set)

note_to :: FilePath -> String -> IO ()
note_to dest msg = do
    id <- getProcessID
    time <- zeit
    appendFile dest ( time ++ " ( " ++ show id ++ " ) " ++ msg ++ "\n" )

err set msg = do note set msg;  error msg

crap :: Settings -> [String] -> String -> String -> IO a
crap set args contents msg = do
    id <- getProcessID
    let fname = (crapfile set) ++ show id ++ (crapfile_ext set)
    writeFile fname (show args ++ "\n" ++ contents)
    err set msg

