

import java.awt.*;
import java.awt.event.*;


public class xSolverFrame extends Frame implements ActionListener
{
	private MenuBar menuBar;
	private Menu fileMenu;
	private Menu helpMenu;
	private MenuItem fileOpen, fileClose;
	private MenuItem helpAbout;
	
	private Viewer myViewer;
	private ControlPanel myController;
	private TextArea statusField;
	
	private Manager myManager;
	

	public xSolverFrame ()
	{

	///////////////////////////////////////      Begin
	//Manager initialisieren
		myManager = new Manager();
		myViewer = myManager.getViewer ();
		myController = myManager.getController ();
	//Manager
	///////////////////////////////////////      End



	
	///////////////////////////////////////      Begin
	//Menu erzeugen und hinzufgen
		menuBar = new MenuBar ();
		fileMenu = new Menu ("Datei");
		helpMenu =new Menu ("Hilfe");
		
		menuBar.add (fileMenu);
		menuBar.add (helpMenu);
		
		fileOpen 	= new MenuItem ("ffnen");
		fileClose 	= new MenuItem ("Beenden");
		helpAbout	= new MenuItem ("About");
		
		fileMenu.add (fileOpen);
		fileMenu.addSeparator();
		fileMenu.add (fileClose);
		helpMenu.add (helpAbout);
		
		setMenuBar (menuBar);
		
		fileOpen.addActionListener(this);
		fileClose.addActionListener(this);
		helpAbout.addActionListener(this);
	//Menu
	///////////////////////////////////////      End

	
	
	////////////////////////////////////////     Begin
	//Window-Events abfangen
		addWindowListener(
				new WindowAdapter()
					{
						public void windowClosing(WindowEvent e)
						{
							myManager.exitProgram ();
						}
					}
		);
	//Window-Events
	///////////////////////////////////////      End
	
	
	///////////////////////////////////////      Begin
	//Panels und Layouts
		statusField = new TextArea(4, 50);
		setLayout (new BorderLayout());
		add ("Center", myViewer);
		add ("East", myController);
		add ("South", statusField);
		pack();
	//Panels und Layouts
	///////////////////////////////////////      End

	}
	
	public void actionPerformed (ActionEvent ae)
	{
		Object source = ae.getSource();
		
		if (source == fileClose)
		{
			myManager.exitProgram ();
		}
		else if (source == helpAbout)
		{
		
		}
		else if (source == fileOpen)
		{
			myManager.loadExercise();
		}
		
	}
}
