import Graph
import Sort
import Set
--import Graph_Util




isomorphgraph :: (Ord a, Eq a) => Graph a -> Graph a -> Bool
isomorphgraph a b = 
  if gradgleich (sort(gradliste(setToList(kanten a))(setToList(knoten a)))) (sort(gradliste(setToList(kanten b))(setToList(knoten b)))) 
    then gradgleich (sort(ordnungliste (setToList(kanten a))(setToList(knoten a)) (gradliste(setToList(kanten a))(setToList(knoten a))) a ))  (sort(ordnungliste(setToList(kanten b)) (setToList(knoten b)) (gradliste(setToList(kanten b))(setToList(knoten b))) b )) 
    else False

gradliste :: (Ord a, Eq a) =>[Kante a] -> [a] -> [Integer]
gradliste a [] = []
gradliste a (b:bs) = [grad a b] ++ gradliste a bs

--
--riskant? bei reflexivitaet einer kante, aber bei hier ja nur voruntersuchung
grad :: (Ord a, Eq a) => [Kante a]-> a -> Integer
grad [] b = 0
grad (a:xa) b = 
  if or[b==von a,b==nach a] 
    then 1 + grad (xa) b 
    else grad (xa) b

  

-- die anderen faelle werden vernachlaessigt, da in isomoph.hs nur graphen gleicher knotenlaenge gegeben werden.
gradgleich :: [Integer] -> [Integer] -> Bool
gradgleich [][] = True
gradgleich (a:as)(b:bs) = 
  if a==b 
    then gradgleich as bs 
    else False


ordnungliste :: (Ord a, Eq a) =>[Kante a] -> [a] -> [Integer] -> Graph a-> [Integer]
ordnungliste a [] c d= [] 
ordnungliste a (b:bs) c d= [ordnung a b c (setToList(knoten d))] ++ ordnungliste a bs c d

ordnung :: (Ord a, Eq a) => [Kante a]-> a -> [Integer] -> [a] -> Integer
ordnung [] b c d = 0
ordnung (a:as) b c d = 
  if b==von a
    then c!!((zaehleab (nach a) d)-1) + ordnung as b c d 
    else
      if b==nach a
        then c!!((zaehleab (von a) d)-1) + ordnung as b c d
        else ordnung as b c d


--finde position eines knoten in knotenliste
zaehleab :: (Ord a, Eq a) => a -> [a] -> Int
-- ERROR: zaehleab a [] = 5000000
zaehleab a (b:bx) = 
  if a==b
    then 1
    else 1 + zaehleab a bx


kanten11 = [Kante {von = 'a', nach = 'b'},Kante {von = 'a', nach = 'd'},
  Kante {von = 'a', nach = 'g'},Kante {von = 'b', nach = 'c'},
  Kante {von = 'b', nach = 'd'},Kante {von = 'c', nach = 'e'},
  Kante {von = 'd', nach = 'e'},Kante {von = 'd', nach = 'f'},
  Kante {von = 'g', nach = 'f'}]

kanten12 = [Kante {von = 'a', nach = 'b'},Kante {von = 'b', nach = 'c'},Kante {von = 'a', nach = 'c'}]


bspgraph10 = Graph{knoten=mkSet['a','b','c','d','e','f','g'], 
    kanten=mkSet[
      kante 'a' 'b',
      kante 'a' 'c',
      kante 'a' 'd',
      kante 'b' 'd',
      kante 'b' 'c',
      kante 'c' 'e',
      kante 'd' 'g',
      kante 'e' 'f',                                        
      kante 'g' 'f',
      kante 'd' 'c',                                        
      kante 'd' 'e'
      ]}
bspgraph11 = Graph{knoten=mkSet['a','b','c','d','e','i','g'], 
    kanten=mkSet[
      kante 'a' 'b',
      kante 'a' 'd',
      kante 'a' 'g',
      kante 'b' 'd',
      kante 'b' 'c',
      kante 'd' 'e',
      kante 'd' 'i',
      kante 'g' 'i',
      kante 'c' 'e',
      kante 'd' 'g',                                        
      kante 'g' 'e'                                            
      ]}

bspgraph1 = Graph{knoten=mkSet['a','b','c','d','e','f'], 
    kanten=mkSet[
      kante 'a' 'b',
      kante 'a' 'd',
      kante 'b' 'd',
      kante 'b' 'e',
      kante 'b' 'c',
      kante 'd' 'e',
      kante 'd' 'f',
      kante 'e' 'f'                                        
      ]}
bspgraph2 = Graph{knoten=mkSet['a','b','c','d','e','f'], 
    kanten=mkSet[
      kante 'a' 'b',
      kante 'a' 'd',
      kante 'b' 'd',
      kante 'b' 'e',
      kante 'b' 'c',
      kante 'd' 'e',
      kante 'd' 'f',
      kante 'e' 'f'                                        
      ]}
bspgraph3 = Graph{knoten=mkSet['a','b','c','d','e','f'], 
    kanten=mkSet[
      kante 'a' 'b',
      kante 'b' 'f',
      kante 'b' 'e',
      kante 'b' 'd',
      kante 'c' 'd',
      kante 'c' 'e',
      kante 'd' 'e',
      kante 'd' 'f'                                        
      ]}
bspgraph4 = Graph{knoten=mkSet['a','b','c','d','e','f'], 
    kanten=mkSet[
      kante 'a' 'b',
      kante 'b' 'f',
      kante 'b' 'e',
      kante 'b' 'd',
      kante 'c' 'd',
      kante 'c' 'e',
      kante 'd' 'e',
      kante 'd' 'a'                                        
      ]}
bspgraph5 = Graph{knoten=mkSet['a','b','c','d','e','g'], 
    kanten=mkSet[
      kante 'b' 'a',
      kante 'b' 'g',
      kante 'b' 'e',
      kante 'b' 'd',
      kante 'c' 'd',
      kante 'c' 'e',
      kante 'd' 'e',
      kante 'd' 'a'                                        
      ]}
