module Normalize where

import NFA_Type

import Set
import FiniteMap

normalize :: Ord s => NFA s -> NFA Int
normalize n = 
    let fm = listToFM $ zip (setToList (states n)) [ 1 .. ]
	fun = lookupWithDefaultFM fm (error "Normalize")
    in	amap fun n

