module Eindeutig 

( eindeutig
)

where

import Grammatik
import Ableitung
import Links_Ableitung

eindeutig :: Maybe Int -> Grammatik -> Either String String
eindeutig schranke g =
    case take 3 $ mehrdeutige_links_ableitungen schranke g of
        [] -> Right $ "Diese Grammatik ist eindeutig."
	xys -> Left  $  unlines $ report xys

report xys = [ "Diese Grammatik ist nicht eindeutig." 
	     , "wenigstens folgende Wrter haben mehrere Links-Ableitungen:" 
	     ] ++ 
	     concat [    [ "Wort: " ++ car x ++ ", Ableitungen: " ]
		      ++ [ "    " ++ show z | z <- [ x, y ] ]
		    | (x, y) <- xys 
		    ]
