module Erreichbar

( erreichbar
)

where

import Monad (guard)

import Set
import Fix
import Grammatik


erreichbar :: Grammatik -> Set Char
erreichbar g = fix ( \ qs -> union qs $ mkSet $ do
    ( [lhs] , rhs ) <- rules g
    guard $ lhs `elementOf` qs   
    p <- rhs
    guard $ p `elem` vars g
    return p
  ) (unitSet $ startsymbol g)


    
