module Mehrdeutig where

import Grammatik
import Set

student = Grammatik
	{ terminale = mkSet "xy+*"
	, nichtterminale = mkSet "E"
	, startsymbol = 'E'
	, regeln = mkSet [ ("E", rechts)
		   | rechts <- [ "x", "y", "E+E", "E*E" ]
		   ]
	}
