-- $Header: /home/joe/scratch/challenger/autotool/grammatik/Multi.hs,v 1.1.1.1 2002/05/24 10:46:47 challenger Exp $

module Multi where

import Grammatik
import Set

import List (inits, tails)

splits xs = zip (inits xs) (tails xs)

multi bew g = do
    res <- sequence $ do
	( pre, miss : post ) <- splits $ setToList $ regeln g
	let g' = g { regeln = mkSet ( pre ++ post ) }
	return $ do 
	       r <- bew g'
	       return (miss, r)
    print res

