-- $Header: /home/joe/scratch/challenger/autotool/grammatik/Simple_Zeige.hs,v 1.1.1.1 2002/05/24 10:46:47 challenger Exp $

module Simple_Zeige

( zeige
, zeige_genau
)

-- $Log: Simple_Zeige.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:47  challenger
-- start
--
-- Revision 1.2  2001/12/01 14:47:33  autotool
-- prekompilierte grader
--
-- Revision 1.1  2001/11/26 13:55:58  autotool
-- stark vereinfachte Anzeige von Ableitungen
--

where

import Set
import Wort
import Grammatik
import Simple_Schichten
import Ableitung
import ToDoc

zeige :: Maybe Int ->  Grammatik -> IO ()
zeige = zeige_genau 5

present :: ToDoc [a] => [a] -> IO ()
present = putStrLn . render . toDoc

zeige_genau :: Int -> Maybe Int -> Grammatik -> IO ()
zeige_genau wschranke gschranke g = do
    putStrLn $ "\nIhre Grammatik G ist"
    -- print g
    putStrLn $ render $ toDoc g

    putStrLn $ "\nIch zeige Ihnen jetzt einige Ableitungen in G\n"
    let xss = schichten (schritt gschranke g) [startsymbol g]
    sequence_ $ do (k, xs) <- zip [0..wschranke] $ xss
		   return $ do putStrLn $ "in " ++ show k ++ " Schritten"
				     ++ " ableitbar:" 
			       present xs
{-  dauert zu lange:
    putStrLn $ "\nDie damit erzeugten Wrter aus Terminalzeichen sind\n"
    let yss = map (filter (all (`elementOf` (terminale g)))) xss
    sequence_ $ do (k, ys) <- zip [0..wschranke] $ yss
		   return $ do putStrLn $ "in " ++ show k ++ " Schritten"
				     ++ " ableitbar: "
			       present ys
-}


