-- $Header: /home/joe/scratch/challenger/autotool/grammatik/Zeige.hs,v 1.1.1.1 2002/05/24 10:46:47 challenger Exp $

module Zeige

( zeige
, zeige_genau
)

-- $Log: Zeige.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:47  challenger
-- start
--
-- Revision 1.7  2001/12/02 18:37:37  mrahn
-- - verbesserungen an vorkompilierten gradern
-- - alle aufgaben aus ws01 mit vorkompilierten gradern umgesetzt
--
-- Revision 1.6  2001/12/01 14:47:33  autotool
-- prekompilierte grader
--
-- Revision 1.5  2001/11/26 13:22:51  autotool
-- nicht 5, sondern nur 4 Schichten anzeigen
-- (behelfs-patsch, keine wirkliche Lsung)
--
-- Revision 1.4  2001/11/20 11:18:27  autotool
-- Zeige.hs: benutze toDoc zum Abschneiden langer listen
--

where

import Set
import Wort
import Grammatik
import Schichten
import Ableitung
import ToDoc

zeige :: Maybe Int ->  Grammatik -> IO ()
zeige = zeige_genau 4

present :: ToDoc [a] => [a] -> IO ()
present = putStrLn . render . toDoc

zeige_genau :: Int -> Maybe Int -> Grammatik -> IO ()
zeige_genau wschranke gschranke g = do
    putStrLn $ "\nIhre Grammatik G ist"
    --    print g
    putStrLn $ render $ toDoc g
   
    putStrLn $ "\nIch zeige Ihnen jetzt einige Ableitungen in G\n"
    let xss = map setToList
	    $ schichten (schritt gschranke g) [startsymbol g]
    sequence_ $ do (k, xs) <- zip [0..wschranke] $ xss
		   return $ do putStrLn $ "in " ++ show k ++ " Schritten"
				     ++ " ableitbar:" 
			       present xs

    putStrLn $ "\nDie damit erzeugten Wrter aus Terminalzeichen sind\n"
    let yss = map (filter (all (`elementOf` (terminale g)))) xss
    sequence_ $ do (k, ys) <- zip [0..wschranke] $ yss
		   return $ do putStrLn $ "in " ++ show k ++ " Schritten"
				     ++ " ableitbar: "
			       present ys


