module NFAExample

where

import NFA 

-- S^* aba S^*

tab :: NFA String Char
tab = addListToFM_C (++) emptyFM 
    $  [ ((q, c), [q]) -- Schleife
       | q <- [ "q0", "q3" ]
       , c <- [ 'a', 'b' ]
       ]
    ++ [ (("q0", 'a'), [ "q1" ])
       , (("q1", 'b'), [ "q2" ])
       , (("q2", 'a'), [ "q3" ])
       ]
	
ex = Machine { start = "q0"
	     , final = mkSet [ "q3" ]
	     , transitions = nfa tab
	     }



