module DPDA 

where

-- $Log: DPDA.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.2  2002/01/13 23:03:33  autotool
-- kellerautomaten: nutze toDoc, akzeptanzmodus sichtbar
--

import Monad (guard)

import NPDA
import Set

ist_deterministisch 
    :: (Ord x, Ord y, Ord z, Show x, Show y, Show z)
    => NPDA x y z -> Either String String
ist_deterministisch a =
    case do x <- setToList $ eingabealphabet a
	    z <- setToList $ zustandsmenge a
	    y <- setToList $ kelleralphabet a
	    let fs =            lookupset (tafel a) (Just x , z, y)
		     `union` lookupset (tafel a) (Nothing, z, y)
	    guard $ cardinality fs > 1
	    return ((x, z, y), setToList fs)
    of []  -> Right "das ist ein deterministischer Kellerautomat"
       fss -> Left $ unlines (
		   [ "das ist kein deterministischer Kellerautomat,"
		   , "denn fr folgende x in X, z in Z, y in Y"
		   , "enthlt  h(x,z,y) + h(epsilon,z,y) mehr als ein Element:"
		   , ""
		   ] ++
		   map show fss )



