-- $Header: /home/joe/scratch/challenger/autotool/pump/pro/Pump.hs,v 1.1.1.1 2002/05/24 10:46:48 challenger Exp $

module Pump

( Pump (..)
, NFA 
, build
, module Zerlegung 
)

where

-- $Log: Pump.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.1  2001/12/05 21:13:33  autotool
-- pump/*/* neu
--

import Zerlegung
import Size
import NFA
import Build
import ToDoc

data Pump = Nein
	     { schnitt :: NFA Int
	     , wort :: Int -> String
	     , expo :: Int -> Zerlegung -> Int
	     }
	  | Ja
	     { n :: Int
	     , zerlege :: String -> Zerlegung
	     }


instance ToDoc Pump where
    toDoc (   Nein {} ) = text $ "Nein { .. }"
    toDoc ( p @ Ja {} ) = text $ "Ja { n = " ++ show (n p) ++ ", .. }"

instance Show Pump where show = render. toDoc

instance Size Pump where
    size n @ Nein {} = sum [ length $ wort n s | s <- [ 1 .. 10 ] ]
    size j @ Ja   {} = n j



	   

       
