module HAM2 (bewerte) where

import Graph
import Graph_Util
import Graph_Hamilton

import Set
import FiniteMap

bewerte student = check ham2 "HAM2" student

ham2 = symmetrisch
       Graph { tafel  = listToFM [ (i, kn i (show i)) | i<-[1..28] ]
             , kanten = mkSet [ ka 5 3
                              , ka 6 4
                              , ka 7 1
                              , ka 8 2
                              , ka 9 3
                              , ka 10 2
                              , ka 10 7
                              , ka 11 1
                              , ka 11 3
                              , ka 11 8
                              , ka 12 2
                              , ka 12 4
                              , ka 12 5
                              , ka 12 9
                              , ka 13 3
                              , ka 13 6
                              , ka 14 4
                              , ka 14 7
                              , ka 15 6
                              , ka 15 12
                              , ka 16 5
                              , ka 16 7
                              , ka 16 13
                              , ka 17 6
                              , ka 17 8
                              , ka 17 10
                              , ka 17 14
                              , ka 18 7
                              , ka 18 9
                              , ka 18 11
                              , ka 19 8
                              , ka 19 12
                              , ka 20 11
                              , ka 20 17
                              , ka 21 10
                              , ka 21 12
                              , ka 21 18
                              , ka 22 11
                              , ka 22 13
                              , ka 22 15
                              , ka 22 19
                              , ka 23 12
                              , ka 23 14
                              , ka 23 16
                              , ka 24 13
                              , ka 24 17
                              , ka 25 16
                              , ka 25 22
                              , ka 26 15
                              , ka 26 17
                              , ka 26 23
                              , ka 27 16
                              , ka 27 18
                              , ka 27 20
                              , ka 27 24
                              , ka 28 17
                              , ka 28 19
                              , ka 28 21
                              ]
             }
