module UNI1 where

import Fun
import Check
import Random

import AL
import Paare
import Builtin

fibs = 0 : 1 : zipWith (+) (drop 1 fibs) fibs
h    = lift1 $ \ n -> unlift2 paar ( fibs !! (fromInteger n + 1) ) 
				   ( fibs !! (fromInteger n ) )

bewerte student = do
    putStrLn $ unlines	
	     [ "Ich bin der automatische Korrektor fr die Aufgabe UNI1."
	     , "Zu finden war eine primitiv-rekursive Definition"
	     , "fr die Funktion h(n) = paar (f(n+1),f(n)),"
	     , "wobei f(n) = die n-te Fibonacci-Zahl."
	     , ""
	     , "Ihre Definition lautet " ++ show student
	     , ""
	     , "Ich prfe erst die Typkorrektheit und rechne dann einige Werte aus."
	     , ""
	     ]

    random <- sequence $ take 5 $ repeat $ do
        x <- randomRIO (0, 10)
	return [ x ]

    let b = foldr1 beide [ al 
			 , paare
			 , builtins [ ("h", h) ]
			 ]
    
    checks 1000 b "h" random student 

