module LoesungTM42 where

import Turing

data Z = Q1 | Q2 | Q3
     deriving (Eq, Ord, Show)

student :: Turing Char Z
student = Turing 
        { eingabealphabet = mkSet "A"
        , leerzeichen     = '#'
        , arbeitsalphabet = mkSet "#ABC"
        , zustandsmenge  = mkSet [ Q1, Q2, Q3 ]
        , tafel = t
        , startzustand   = Q1
        , endzustandsmenge = mkSet [ Q3 ]
        }


t = listToFM
      [ ( ('A', Q1), mkSet [ ( 'B', Q1, O ) ] )
      , ( ('B', Q1), mkSet [ ( '#', Q1, R ) ] )
      , ( ('#', Q1), mkSet [ ( 'A', Q2, O ) ] )
      , ( ('A', Q2), mkSet [ ( 'B', Q2, O ) ] )
      , ( ('B', Q2), mkSet [ ( '#', Q3, O ) ] )
      ]


