-- Der Anfang wird beim Mailinterface von Autotool_Main geschrieben
-- ungefhr so wie hier
module Main (main) where

import TM44 (bewerte)
import Turing -- steht eigentlich im zweiten Teil

main = do
       res <- bewerte student
       putStr res

-- So was steht dann in der Email und wird von Autotool_Main in ein Student$$
-- File geschrieben, das im oberen Teil noch importiert wird.

data Z = A0 | A1 | A2 | F
         deriving (Eq, Ord, Show)

student :: Turing Char Z
student = Turing 
        { eingabealphabet  = mkSet "A"
        , leerzeichen      = '#'
        , arbeitsalphabet  = mkSet "#ATEW"
        , zustandsmenge    = mkSet [ A0, A1, A2, F ]
        , tafel            = t
        , startzustand     = A0
        , endzustandsmenge = mkSet [ F ]
        }

t = listToFM
      [ ( ('#', A0), mkSet [ ( '#', F, O ) ] )
      , ( ('A', A0), mkSet [ ( 'A', A1, R ) ] )

      , ( ('#', A1), mkSet [ ( '#', F, O ) ] )
      , ( ('A', A1), mkSet [ ( 'E', A2, R ) ] )

      , ( ('E', A2), mkSet [ ( 'E', F, O ) ] )
      , ( ('#', A2), mkSet [ ( '#', A2, L ) ] )
      , ( ('A', A2), mkSet [ ( 'W', A2, R ) ] )
      , ( ('W', A2), mkSet [ ( 'T', A2, R ) ] )
      , ( ('T', A2), mkSet [ ( 'A', A2, L ) ] )
      ]
