module Baum.Ops where

import Baum.Type

clip :: Int -> Baum a -> Baum (Maybe a)
-- in Tiefe d abschneiden
clip d b =
    if d < 0 
    then Baum { wurzel = Nothing
	      , kinder = [] 
	      }
    else Baum { wurzel = Just (wurzel b)
	      , kinder = map (clip (d-1)) $ kinder b
	      }

