module Bild.Edit where

import Language.Edit
import Bild.Type
import Bild.Ops

import Random


instance Edit (Bild s) where
    edit b | ist_leer b = return b
	   | otherwise  = do
	         k <- randomRIO (0, length edit_ops - 1)
		 (edit_ops !! k) b

edit_ops :: [ Bild s -> IO (Bild s) ]
edit_ops = 
	[ \ b -> do 
		    return $ drehe b
	, \ b -> do x <- randomRIO (0, breit b - 1)
		    return $ unspalte b x
	, \ b -> do y <- randomRIO (0, hoch  b - 1)
		    return $ unzeile b y
	, \ b -> do x <- randomRIO (0, breit b - 1)
		    return $ the $ neben b $ spalte b x
	, \ b -> do y <- randomRIO (0, hoch  b - 1)
		    return $ the $ auf   b $ zeile  b y
	, \ b -> do p <- somewhere b
		    q <- somewhere b
		    return $ to b (q, b `at` p)
	]
