module Bild.Squares where

import Bild
import Language

import ToDoc
import Random
import Set

squares :: Language Char (Bild Char)
squares = Language 
     { name = "SQUARES"
     , definition = braces $ text "b : breit (b) = hoch (b)"
     , alphabet     = mkSet "01"
     , contains = \ b -> breit b == hoch b
     , sample = \ c n -> sequence $ replicate c $ irgendein (n, n) "01"
     , anti_sample = anti squares
     }

