module Language.Address where

import Language.Object

class Directed p d where
    move :: p -> d -> p

class Object a o => Address a o p | o -> p where
    peek :: o -> p -> Maybe a

class Top o p where
    top :: o -> p

class Whoami p where
      whoami :: p -> String

