-- $Id: Complement.hs,v 1.1.1.1 2002/05/24 10:47:03 challenger Exp $

module Language.Complement where

import Language.Type
import Language.Edit

import ToDoc

complement :: Language a o -> Language a o
complement l = Language
	   { name = "Komplement von " ++ name l
	   , definition = text "Komplement von" <+> parens ( definition l )
	   , _size = _size l
	   , alphabet = alphabet l
	   , contains = not . contains l
	   , sample = anti_sample l
	   , anti_sample = sample l
	   }

-- kann man als anti_sample-implementierung nehmen,
-- wenn man sonst keine idee hat
anti :: Edit o 
     => Language a o -> Sampler o
anti l = \ c n -> do
     os <- sample l c n >>= mapM edits 
     return $ filter (not . contains l) os
