module Local.Check where

import Local.Type
import Local.Cover

import Language
import Language.Comp

import Bild

import ToDoc
import Size

import Right 
import Wrong



language :: ( Ord s, ToDoc [Bild s], ToDoc s)
	 => Local s -> Language s (Bild s)
language loc =
  Language   { name = "local"
             , definition = toDoc loc
             , alphabet = alpha loc
             , contains = null . missing loc

             , sample = \ c n -> return [] -- leider nix da
	     , anti_sample = \ c n -> return []

             , _size = size loc
             }

check :: ( Ord s, ToDoc [Bild s], ToDoc s, ToDoc [s], Show [Bild s])
      => Int -- Anzahl der testbilder
      -> Int -- startgre
      -> Language s (Bild s) -> Local s 
      -> IO String
check number size lang student =
    comp number size lang (language student)

