-- $Header: /home/joe/scratch/challenger/autotool/util/DPL_Set.hs,v 1.1.1.1 2002/05/24 10:46:48 challenger Exp $

module DPL_Set

( value, values )

where

-- $Log: DPL_Set.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.2  2001/11/29 13:41:20  autotool
-- CF_advanced: besserer parser, hrtere tests
--
-- Revision 1.1  2001/11/28 07:25:23  autotool
-- neu: DPL*
--

import qualified DPL
import Simple_Set
import Monad ( guard )
-- import Set

lift ::  Ord b
     => ( (b,b) -> Set b )  
     -> ( [(Set b, Set b)] -> Set b )
lift combine xys = mkSet $ do
     (xs, ys) <- xys
     guard $ not $ isEmptySet xs
     guard $ not $ isEmptySet ys 
     x <- setToList xs
     y <- setToList ys
     setToList $ combine (x, y)

value :: (Ord a, Ord b) 
      =>  (a -> Set b) -> ((b,b) -> Set b) -> [a] -> Set b
value unit combine = DPL.value unit (lift combine)

values :: (Ord a, Ord b) 
      =>  (a -> Set b) -> ((b,b) -> Set b) -> [[a]] -> [([a],Set b)]
values unit combine = DPL.values unit (lift combine)

