-- $Header: /home/joe/scratch/challenger/autotool/util/Report.hs,v 1.1.1.1 2002/05/24 10:46:48 challenger Exp $

module Report 

( Report (..)
, when
, assert
)

where

import Monad

data Report a = OK a | Fail String
	deriving ( Eq, Ord, Show )

instance Functor Report where
    fmap f (OK a) = OK (f a)
    fmap f (Fail msg) = Fail msg

instance Monad Report where
    return = OK
    OK x >>= f = f x; Fail msg >>= f = Fail msg
    fail = Fail

assert :: Bool -> String -> Report ()
assert p msg =
    if p then return () else fail msg


