module Some where

import Size
import Random

-- some n  soll ein  x :: a  liefern mit  size x == n

class Size a => Some a where
    some :: Int -> IO a


somepermutation :: Int -> IO [ Int ]
-- irgendeine anordnung der zahlen [ 1 .. n ]
somepermutation 0 = return []
somepermutation n = do
    xs <- somepermutation (n-1)
    k <- randomRIO (0, n-1)
    let (pre, post) = splitAt k xs
    return $ pre ++ n : post    

somepartition :: Int -> Int -> IO [ Int ]
-- erzeugt liste der lnge l von zahlen > 0 mit summe s
somepartition 1 s = return [ s ]
somepartition l s | l > s = error $ "somepartition" ++ show (l,s)
somepartition l s = do
    let b = s + 1 - l -- grte mgliche zahl
    x <- randomRIO (1, b) -- die nehmen wir
    k <- randomRIO (0, l-1)
    xs <- somepartition (l-1) (s-x)
    let (pre, post) = splitAt k xs
    return $ pre ++ x : post

