module Aufgabe58

where

import Wort
import Wahl
import Random
import Akzeptieren
import NPDATest

-- korrekt geklammert, lnge = 2 * h
korrekt :: Int -> IO String
korrekt h = if 0 == h then return "" else do
    k <- randomRIO (0, h - 1)
    u <- korrekt k; v <- korrekt (h - k - 1)
    return $ "a" ++ u ++ "b" ++ v 

-- balance ist irgendwann unter null
unter :: Int -> IO String
unter 1 = return "b"
unter h = do
    k <- randomRIO (0, h `div` 2 - 1)
    p <- korrekt k
    q <- someIO "ab" (h - 2 * k - 1)
    return $ p ++ "b" ++ q

-- balance ist immer uber null
uber :: Int -> IO String
uber 1 = return "a"
uber h = do
    k <- randomRIO (0, h `div` 2 - 1)
    p <- korrekt k
    q <- guber (h - 2 * k - 1)
    return $ p ++ "a" ++ q

-- balance ist ber oder gleich null
guber h = if even h then whle (korrekt (h `div` 2)) (uber h)
		    else                             uber h

------------------------------------------------------------------------


gute      = sequence $ take 10 $ repeat $ do k <- randomRIO (2, 10); uber   k
schlechte = sequence $ take 10 $ repeat $ do k <- randomRIO (2, 10); unter  k

-----------------------------------------------------------------------


bewerte student = do
    putStrLn $ unlines
	     [ "Ich bin der automatische Korrektor fr Aufgabe V.8."
	     , ""
	     , "Die Sprache aller  w  in  {a, b}* mit"
	     , "forall prfix  u  von  w  gilt  l_a(u) >= l_b(u)"
	     , "soll durch einen deterministischen Kellerautomaten" 
	     , "durch Endzustnde akzeptiert werden."
	     , ""
	     , "Siehe auch http://www.informatik.uni-leipzig.de/~joe/edu/ws00/auspra/autotool/pda.html"
	     , ""
	     ]
    p <- gute
    n <- schlechte
    testDPDA 1000 akzeptierend_mit_endzustand p n student
