module Aufgabe93 where

import Turing
import Turing_Test

import Wort
import Random
import List (inits)

primes :: [ Int ]
primes = sieve [2 .. ] where 
    sieve (p : xs) = p : sieve (filter (not . (== 0) . (`mod` p)) xs)

smallprimes = takeWhile (< 14) primes

pos = do (x, y) <- zip smallprimes (drop 1 smallprimes)
	 z <- [ x + 1 .. y - 1 ]
	 return $ take z $ repeat 'I'

neg = do z <- smallprimes
	 return $ take z $ repeat 'I'
    

--------------------------------------------------------------------

bewerte student = do
    putStrLn $ unlines
	     [ "Ich bin der automatische Korrektor fr Aufgabe IX.3."
	     , ""
	     , "Die Sprache { I ^ (a * b) | a, b > 1 }"
	     , "soll durch eine Turingmaschine akzeptiert werden"
	     , ""
	     ]
    test 5000 pos neg student

