import Grammatik 
import Aufgabe42b

import Schichten
import Ableitung
import Set

student = Grammatik
	{ terminale = "a"
	, nichtterminale = "SHKFLRAB"
	, startsymbol = 'S'
	, regeln = [ ("S", "a"), ("S", "aa") -- kleine Wrter von Hand bauen
		   , ("S", "LHAR") -- hier gehts los
		   , ("HA", "BBH") -- nach rechts fahren
		   , ("HR", "KR")  -- umschalten
		   , ("BK", "KA") -- nach links fahren
		   , ("LK", "LH") -- zurckschalten oder
		   , ("LHA", "aaF") -- finalisieren
		   , ("FA", "aaaaF") -- nach rechts fahren
		   , ("FR", "aa")  -- abschalten
		   ]
	}

{-

Erklrung: es gibt drei Maschinenzustnde,
die erkennt man am Vorkommen des Nichtterminals H, K, F

wir starten mit Bandinhalt L H A^(2^n) R 
(zu Beginn fr n = 0)

H:  Das Wort ist   L B...B H A...A R

    Falls keine B da sind, knnen wir LHA -> aaF nehmen, siehe unten

    Ansonsten ist die einzige anwendbare Regel HA -> BBH

    schlielich  L B^(2^(n+1)) HR ->  L B^(2^(n+1)) KR 

K:  Das Wort ist   L B...B K A...A R
    einzige anwendbare Regel ist  BK -> KA

    schlielich L K A^(2^(n+1)) R -> L H A^(2^(n+1)) R 

F:  Das Wort ist   a...a F A...A R

    zu Beginn  aa F A^(2^n-1) R

    einzige anwendbare Regel ist  FA -> aaaaF

    schlielich  aa a^(4*(2^n-1)) FR -> aa a^(4*(2^n-1)) aa 
    = a^(4*2^n) = a^(2^(n+2)) 

wir erhalten also alle Wrter a^(2^(n+2)).
deswegen mssen wir am Anfang a^1 und a^2 von Hand erzeugen.

-}
