module Loesung43 where

import Aufgabe43

import NPDA

data Z = Z0 | Z1 
     deriving (Eq, Ord, Show)

-- der Automat soll { u a v b  |  |u| = |v| }
-- durch leeren Keller akzeptieren

student :: NPDA Char Char Z
student = NPDA { eingabealphabet = mkSet "ab"
	       , kelleralphabet  = mkSet "Sc"
	       , zustandsmenge	 = mkSet [ Z0, Z1 ]
	       , tafel = t
	       , startzustand	 = Z0
	       , startsymbol	 = 'S'
	       , endzustandsmenge = emptySet
	       }


t = addListToFM_C unionSet emptyFM $
    -- speichern
    [ ( ( Just x, Z0, y ), mkSet [ ( Z0, [ 'c', y ] ) ] )
    | x <- "ab" ,  y <- "Sc"
    ]
    ++ -- wechseln
    [ ( ( Just 'a', Z0, y ), mkSet [ ( Z1, [y] ) ] )
    | y <- "Sc"
    ] 
    ++ -- prfen
    [ ( ( Just x, Z1, 'c' ), mkSet [ ( Z1, "" ) ] )
    | x <- "ab" 
    ]
    ++ -- aufhren
    [ ( ( Just 'b', Z1, 'S' ), mkSet [ ( Z1, "" ) ] )
    ]


