import NFA1

import NFA
import Set
import FiniteMap

student2 :: NFA Int
student2 = NFA { states = mkSet [1..7]
              , starts = mkSet [3,6]  
              , finals = mkSet [1]     
              , trans  = listToFM  [ ((1, 'a'), mkSet [2])
                                   , ((1, 'b'), mkSet [3])

                                   , ((2, 'a'), mkSet [1]) 
                                   , ((2, 'b'), mkSet [4])

                                   , ((3, 'a'), mkSet [7])  
                                   , ((3, 'b'), mkSet [5])  

                                   , ((4, 'a'), mkSet [7])  
                                   , ((4, 'b'), mkSet [6])  

                                   , ((5, 'a'), mkSet [7])  
                                   , ((5, 'b'), mkSet [3])  

                                   , ((6, 'a'), mkSet [7])  
                                   , ((6, 'b'), mkSet [4])  

                                   , ((7, 'a'), mkSet [7])  
                                   , ((7, 'b'), mkSet [7])  
                                   ] 
              }



student1 :: NFA Int
student1 = NFA 
 { states = mkSet [1 .. 9 ]
 , starts = mkSet [8]
 , finals = mkSet [4,5,7,8]
 , trans  = collect 
       [  (1, 'a',2)
        , (1, 'b',3)
        , (2, 'a',4)
        , (2, 'b',6)
        , (3, 'a',6)
        , (3, 'b',5)
        , (5, 'a',9)
        , (5, 'b',5)
        , (4, 'b',9)
        , (4, 'a',4)
        , (6, 'b',8)
        , (6, 'a',7)
        , (7, 'a',7)
        , (7, 'b',9)
        , (8, 'a',9)
        , (8, 'b',8) 
        , (9, 'a',9)
        , (9, 'b',9)
       ] 
}
