---------------------------------------------------------------------

classes :: IO [ String ]
classes = do
    let mehr n gen = fmap concat $ sequence $ replicate n $ gen

    cls11 <- class1 2
    cls12 <- class1 3

    cls21 <- mehr 3 $ class2 1    
    cls22 <- mehr 2 $ class2 2    

    cls31 <- mehr 6 $ class3 1
    cls32 <- mehr 3 $ class3 2

    return $ cls11 ++ cls12 ++ cls21 ++ cls22 ++ cls31 ++ cls32

class1 n = do
    let x = 2^n - 1 
    d <- randomRIO (1,3)
    let y = x+2*d+1 
    z <- randomRIO (y+1, y+3)
    return [ encode [1..x] ++ encode[y..z] ]

class2 n = do
    x <- randomRIO (1, 2^n-1)
    d <- randomRIO (2^(n-1), 2^(n-1)+3)
    let y = x + 2*d + 1
    e <- randomRIO (1, 3)
    return     [ encode [1..x] ++ encode [y..y+e]
	       , encode [1..y] ++ encode [x..x+e]
	       ]

class3 n = do
    let d = 2^n
    e <- randomRIO (1,d)
    x <- randomRIO (2*d, 2*d+e)
    return     [ encode [1 .. x] ++ encode [x-d+1 .. x-d+e] 
	       , encode [1 .. x] ++ encode [x+d+1 .. x+d+e] 
	       ]
    

