-- $Header: /home/joe/scratch/challenger/autotool/ws01/aufgaben/CRCL.hs,v 1.3 2002/05/28 07:10:05 joe Exp $

module CRCL where

import Exp
import qualified Env as E
import Syntax
import Sanity
import Inter
import Set
import Vergleiche
import Size
import Auswertung

bewerte :: String ->  Exp -> IO String
bewerte mat exp = do
    putStrLn $ "Ich bin das Korrekturprogramm fr Aufgabe CRCL."

    putStrLn $ "\nSie haben diesen regulren Ausdruck S eingesandt:"
    print exp

    let s = size exp
    putStrLn $ "\nDieser Ausdruck enthlt " ++ show s ++ " Zeichen und Operatoren."
    mu ( if s < 100 then Right "" 
	  else Left  "Das sind mir zu viele. Gre 100 gengt!"
	) $ do

      let ok = "OK # Size: " ++ show s
      check ok exp

check ok exp = do
      let alpha = "ab"
      let std = std_sigma alpha
      sane (mkSet alpha) (E.keys std) exp $ do
            let xa   = read "a a^2^*" :: Exp
            let aah  = inter std $ xa
	    let stud = inter std $ exp
	    let env  = E.make [ ("A", aah), ("B", stud) ]
	    let goal = read $ "b + B B B + B A B + B A A + A A B" :: Exp
	    let beh  = inter env $ goal
	    putStrLn $ unlines
	       [ "Ich vergleiche jetzt Ihre Sprache L"
	       , "mit der Sprache X, die man erhlt,"
	       , "wenn man im Ausdruck " ++ show goal
	       , "jedes A durch " ++ show xa ++ " und jedes B durch Ihr L ersetzt."
	       ]
	    vergleiche_with_msg ok ( "L", stud) ("X", beh)






