--- $Header: /home/joe/scratch/challenger/autotool/ws01/aufgaben/Primitive.hs,v 1.1.1.1 2002/05/24 10:46:49 challenger Exp $

module Primitive where

-- $Log: Primitive.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:49  challenger
-- start
--
-- Revision 1.10  2001/12/01 14:47:33  autotool
-- prekompilierte grader
--
-- Revision 1.9  2001/11/29 13:41:20  autotool
-- CF_advanced: besserer parser, hrtere tests
--
-- Revision 1.8  2001/11/28 09:00:51  autotool
-- lieber doch bis lnge 30
--
-- Revision 1.7  2001/11/28 08:55:40  autotool
-- erzeuge Wrter nur bis zu Lnge 24
--
-- Revision 1.6  2001/11/27 20:57:28  autotool
-- CYK: benutze Simple_Set statt Set (ist lazier)
--
-- Revision 1.5  2001/11/26 13:56:18  autotool
-- stark vereinfachte Anzeige von Ableitungen
--
-- Revision 1.4  2001/11/23 11:06:25  autotool
-- mehr tests
--
-- Revision 1.3  2001/11/23 08:32:28  autotool
-- mehr wrfeln in Primitive.hs
--
-- Revision 1.2  2001/11/21 16:44:06  autotool
-- bessere version von Chomsky.hs
-- bessere testflle fr CF4
--
-- Revision 1.1  2001/11/20 11:15:56  autotool
-- revision aufgabe CF3 (a und b und Primitive.hs)
--
-- Revision 1.1  2001/11/18 23:58:38  autotool
-- neu: aufgaben zu kontextfreien grammatiken
--

import Grammatik
import Typen
import Simple_Zeige
import Wort
import List (nub)
import CF_Check
import Monad (guard)

kuh :: String -> Int -> Int -> Grammatik -> IO String
kuh msg expo top g = do

    putStrLn $ unwords
	     [ "Ich bin das Korrekturprogramm fr die Aufgabe"
	     , msg, "."
	     ]
    muss ( typ2 g ) $ do
 
       zeige (Just 10) g

       let sigma = "01"

       let large = top `div` expo
       this <- mapM (someIO sigma) [ 1, 3 .. top ]
       let drin = do
		w <- this 
		let ww = concat $ replicate expo w 
		guard $ length ww < top
		return ww
       let cand = alles sigma 5 ++ {- this ++ -} drin
    
       cf_check (not . is_power expo ) cand g


is_power :: Eq a => Int -> [a] -> Bool
is_power expo w = 
             let n = length w
		 parts = splits (n `div` expo) w
	     in	 null w 
		 || ( (0 == n `mod` expo) &&  1 == length ( nub parts ) )
	       

splits :: Int -> [a] -> [[a]]
splits d [] = []
splits d xs = 
       let (pre, post) = splitAt d xs
       in  pre :  splits d post





