import Set
import NFA

xys :: [ (Int, Int) ]
xys =  [ (x,y) | x <- [0..1], y <- [0..1] ]

student :: NFA Int
student = normalize NFA 
   { states = mkSet xys
   , starts = mkSet [ (0,0) ]
   , finals = mkSet [ (0,0) ]
   , trans  = collect 
       (  [ ((x,y), 'a', ( succ x `mod` 2, y) ) | (x,y) <- xys ]
       ++ [ ((x,y), 'b', (x, succ y `mod` 2 ) ) | (x,y) <- xys ]
       )
   }

