module Graph_Clique_Solve where

import Graph
import Graph_Util
import Graph_Clique

import Set
import FiniteMap

-------------------------------------------------------------------------------

grssereCliquen :: Ord a => Graph a -> [[a]] -> [[a]]
grssereCliquen g xs =
    setToList ( mkSet( filter ( \l -> length l > length (head xs) )
                              [ setToList (mkSet (l ++ [x]) )
                              | l <- xs, x <- knotenl g, istClique g (l ++ [x])
                              ]
                     )
              )

alleGrsstenCliquen :: Ord a => Graph a ->  [[a]] -> [[a]]
alleGrsstenCliquen g xs =
   let gC = grssereCliquen g xs
   in case gC of
           []  -> xs
           gCl -> alleGrsstenCliquen g gCl
