module Aufgabe44c where

import Set
import Grammatik
import Monad (guard)

import Aufgabe44common

primes :: [ Int ]
primes = sieve [2 .. ] where 
    sieve (p : xs) = p : sieve (filter (not . (== 0) . (`mod` p)) xs)

ziel top = mkSet $ do
    p <- takeWhile (<= top) primes
    return $ take p (repeat 'a')

bewerte :: Grammatik -> IO ()
bewerte = bew 12 ziel
