module Aufgabe47b where

import Turing
import Turing_Test

import Wort
import Random
import List (inits)

isok :: String -> Bool
isok w =
    let count x = length . filter ( == x ) 
    in	count '1' w == 2 * count '0' w

right l = do
    w <- someIO "01" (3*l)
    if isok w then return w else right l

wrong l = do
    w <- someIO "01" l
    if isok w then wrong l else return w
    
posIO = do
    random <- sequence $ take 10 $ repeat $ do
	 l <- randomRIO (2, 4); right l
    let fixed = [ "", "110", "011", "110" ]
    return $ fixed ++ random

negIO = do
    random <- sequence $ take 10 $ repeat $ do
	 l <- randomRIO (1, 10); wrong l
    let fixed = [ "0", "1", "1100", "0110" ]
    return $ fixed ++ random


--------------------------------------------------------------------

bewerte student = do
    putStrLn $ unlines
	     [ "Ich bin der automatische Korrektor fr Aufgabe IV.7b."
	     , ""
	     , "Die Sprache { w | w in {0,1}^*, l_1(w) = 2 * l_0(w) }"
	     , "soll durch eine Turingmaschine akzeptiert werden"
	     , ""
	     , "Siehe auch http://www.informatik.uni-leipzig.de/~joe/edu/ws00/auspra/autotool/turing.html"
	     , ""
	     ]
    pos <- posIO
    neg <- negIO
    test 5000 pos neg student

