module Grundy

( module Grundy
, module Labelled
)

where

import Next
import Labelled

data Grundy = Grundy { unGrundy :: Int } 
     deriving (Eq, Ord)

instance Show Grundy where show = show . unGrundy

mex :: [ Int ] -> Int
mex xs = head $ filter ( \ x -> not (elem x xs) ) [ 0 .. ]

instance Label Grundy where
    label = Grundy . mex . map unGrundy

grundy :: Next a => a -> Labelled a Grundy
grundy = build


