-- $Id: Defaults.hs,v 1.1.1.1 2002/05/24 10:46:45 challenger Exp $

module Defaults where

-- $Log: Defaults.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:45  challenger
-- start
--
-- Revision 1.4  2002/01/18 13:41:31  mrahn
-- - ultrasimples per-User-Slot-Locking eingebaut
--
-- Revision 1.3  2002/01/17 11:17:15  autotool
-- max_mail_size = 20k
--
-- Revision 1.2  2001/12/02 18:37:37  mrahn
-- - verbesserungen an vorkompilierten gradern
-- - alle aufgaben aus ws01 mit vorkompilierten gradern umgesetzt
--
-- Revision 1.1  2001/11/22 10:41:16  mrahn
-- - Kommandozeile verarbeiten
--

import Settings_Type

-- these values are un-adjusted

default_settings = 
    Settings 
     { sender   = ""
     , exercise = ""

     , sourcedir = "."
    
     , workdir   = "work/"
     , donedir   = "done/"
     , bindir    = "bin/"
     , configdir = "config/"
     , logdir    = "log/"
     , crapdir   = "crap/"
     , queuedir  = "queue/"
     , lockdir   = "lock/"
    
     , logfile    = "LOG"
     , resultfile = "RES"
     , crapfile   = "CRAP"
    
     , crapfile_ext = ".text"

     , dispatch_file  = "dispatch"
     , user_files     = [ "operators.dat" ]
     , signature_file = "signature"

     , verboten = [ "IOExts", "System", "Posix" ]

     , max_mail_size               = 20480
     , mail_to_large_message_file  = "mail_to_large_message"

     , max_length_of_showed_input  = 20480
     , input_to_large_message_file = "input_to_large_message"

     , slot_not_free_message_file = "slot_not_free_message"

     , max_mem_for_grader = "10m"

     , runhugs = "runhugs -98 +o"
     , ghc     = "ghc --make -fglasgow-exts -fallow-overlapping-instances -fallow-undecidable-instances -package data -package text -lncurses"
     , rmail   = "/usr/bin/mail"
    }








