-- $Id: Settings_Print.hs,v 1.1.1.1 2002/05/24 10:46:45 challenger Exp $

module Settings_Print where

-- $Log: Settings_Print.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:45  challenger
-- start
--
-- Revision 1.1  2001/11/22 10:41:16  mrahn
-- - Kommandozeile verarbeiten
--

import Settings_Type
import Options

instance Show Settings where
   showsPrec p s = showString $ unlines 
       $ [ "actual settings:"
	 , keyval "sender" $ sender s
	 , keyval "exercise" $ exercise s
         ]
         ++
	 map optInfoToOut (drop 2 $ optInfo s)

       where 
        optInfoToOut (s,l,a,i,v) 
	    | s == ""   = keyval ("  " ++ "  --" ++ l) v
	    | otherwise = keyval ("-" ++ s ++ "  --" ++ l) v

        keyval k v = "  " ++ fill k ++ " = " ++ v

        fill s = take (maximum [n,length s]) $ s ++ take n (repeat ' ')
                      where n = 20
