module Component.Ident where

import Expression
import ToDoc

data Ident = Ident String
     deriving (Eq, Ord)

instance Expressive Ident where
    toExp (Ident i) = Id i
    fromExp (Id i) = Ident i


instance ToDoc Ident where    
    toDoc = toDoc . toExp

instance Show Ident where
    show = showExp

instance Read Ident where
    readsPrec = readExp

