import java.awt.*;
import java.awt.event.*;



public class ControlPanel extends Panel implements ActionListener
{
	private Button connectButton;	//Button
	private Manager myManager;
	
	
	public ControlPanel (Manager m)
	{
		myManager = m;
		connectButton = new Button(" Connect ");
		connectButton.addActionListener(this);
	
		setLayout(new GridLayout(1,1));
		add(connectButton);
	
	}

	public void actionPerformed(ActionEvent ae)
	{
		Object source = ae.getSource();
		
		if (source == connectButton)
		{
			myManager.sendMessage("Clicked {ident=L1}");
		}
	}
}
