

import java.util.*;


public class Queue
{
	private Vector vectorQueue;
	private int position;
	private int anzahl;
	

	public Queue()
	{
		vectorQueue = new Vector();
		position = 0;
		anzahl = 0;
	}
	
	public void addTail (Object o)
	{
		vectorQueue.addElement (o);
		anzahl++;
	}
	
	public void replaceElement (Object o)
	{
		if (position > 0)
		{
			vectorQueue.setElementAt (o, position-1);
		}
	}
	
	public Object getHead ()
	{
		if (!isEmpty())
		{
			return vectorQueue.elementAt(0);
		}
		else return null;
	}
	
	public Object getNext ()
	{
		if (!isEmpty())
		{
			if (position < anzahl)
			{
				Object o = vectorQueue.elementAt (position);
				position++;
				return o;
			}
			else return null;
		}
		else return null;
	
	}
	
	public void setPosition (int pos)
	{
		position = pos;
	}
	
	public boolean removeFromQueue (Object o)
	{
		boolean result = vectorQueue.removeElement(o);

		if (result == true) 
		{
			anzahl--;
		}
		
		return result;
		
	}
	
	public boolean isEmpty()
	{
		return vectorQueue.isEmpty();
	}
}