

module Zeit( 
      zeit
    , sekundenDifferenz
    , Time.CalendarTime (..) 
    ) where

import Time

zeit :: IO(CalendarTime)
zeit = do
    ct <- getClockTime
    cal <- toCalendarTime ct
    return cal

-- | berechnet die Zeitdifferenz in Sekunden
-- nicht ganz korrekt, da ein Monat unterschiedlich viele Tage haben kann!!!
sekundenDifferenz:: CalendarTime->CalendarTime-> Int
sekundenDifferenz time1 time2 = 
  let
  diff= diffClockTimes (toClockTime time1) (toClockTime time2)
  seconds= (tdSec diff)+
           ((tdMin diff)+
           ((tdHour diff)+
           ((tdDay diff)+
           ((tdMonth diff)+
           (tdYear diff)*12)*31)*24)*60)*60
  in seconds
