module Mirror where

import NFA_Type
import qualified Ops

import Set
import FiniteMap

mirror :: Ord s => NFA s -> NFA s
mirror a = 
    let trans' = addListToFM_C union emptyFM $ do
	    ((p, c), qs) <- ltrans a
	    q <- setToList qs
	    return ((q, c), unitSet p) 
    in	a { starts = finals a
	  , finals = starts a
	  , trans = trans'
	  }

    

