module Paare where

import Builtin


paar = lift2 $ \ x y -> let s = x + y ; d = (s * (s + 1)) `div` 2 in d + y

rechts = lift1 $ \ n ->
     let s = floor (sqrt (2 * (fromIntegral n) + 0.25) - 0.5 ) 
	 d = (s * (s + 1)) `div` 2
     in  n - d

links = lift1 $ \ n -> 
     let s = floor (sqrt (2 * (fromIntegral n) + 0.25) - 0.5 ) 
	 d = (s * (s + 1)) `div` 2
     in  s - (n - d)      

paare :: Builtins
paare = builtins 
      [ ( "links", links), ( "rechts", rechts ), ( "paar" , paar ) ]

