module Table 

( table1, table2, tafel )

where

import Fun
import Builtin

import Eval

tab = 5 :: Int

hstrich width = take (tab * (fromIntegral width + 3)) $ repeat '-'
leer k = take k $ repeat ' '
out s =  s ++ leer (tab - length s)
outsh :: Show a => a -> String
outsh = out . show
vstrich = out "  |"

kopf width msg = unlines $
    [ out msg ++ vstrich
      ++  do x <- [ 0 .. width ]; outsh x
    , hstrich width
    ]
    
zeig :: Int -> Builtins -> Fun -> [ Integer ] -> String
zeig steps b f args = 
    let ( msg, cache, res ) = evaluate b f args
    in  out $ if null $ drop steps msg
	      then let s = show res
		   in  if length s < tab
		       then s
		       else "gro"
	      else "lang"

table1 :: Integer -> Int -> Builtins -> Fun -> String
table1 width steps b f = kopf width "x" 
    ++ out "f(x)" ++ vstrich ++ do 
         n <- [0 .. width]; zeig steps b f [ n ]


table2 :: Integer -> Int -> Builtins -> Fun -> String
table2 width steps b f = kopf width "x \\ y" ++ do
         x <- [ 0 .. width ]
	 outsh x ++ vstrich ++ do
	     y <- [ 0 .. width ]
	     zeig steps b f [ x, y ]
	   ++ "\n"

tafel :: Int -> Integer -> Int -> Builtins -> Fun -> String
tafel ar width steps b f =
    "Wertetabelle:\n" ++ 
    case ar of
        1 -> table1 width steps b f
	2 -> table2 width steps b f
	_ -> "(kann ich nur fr ein- und zweistellige Funktionen)"

