-- $Header: /home/joe/scratch/challenger/autotool/grammatik/CYK_Tables.hs,v 1.1.1.1 2002/05/24 10:46:47 challenger Exp $

module CYK_Tables 

( module Simple_Set

, ctable
, vtable
, table_lookup
)

where

-- $Log: CYK_Tables.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:47  challenger
-- start
--
-- Revision 1.2  2001/11/29 13:41:20  autotool
-- CF_advanced: besserer parser, hrtere tests
--
-- Revision 1.1  2001/11/28 07:27:11  autotool
-- benutze DPL in CYK/CF_Chomsky
--

import FiniteMap
import Simple_Set
-- import Set
import Chomsky

import Array

table_lookup fm = lookupWithDefaultFM fm emptySet

ctable :: Ord a => Rules a -> FiniteMap Char (Set a)
-- tafel fr characters (terminale)
ctable rules = addListToFM_C union emptyFM $ do
    ( lhs, Left c ) <- rules
    return ( c, unitSet lhs )

vtable :: Ord a => Rules a -> FiniteMap (a, a) (Set a)
-- tafel fr paare von variablen
vtable rules = addListToFM_C union emptyFM $ do
    ( lhs, Right (x, y) ) <- rules
    return ( (x, y), unitSet lhs )




    