-- $Header: /home/joe/scratch/challenger/autotool/grammatik/DPL_CYK.hs,v 1.1.1.1 2002/05/24 10:46:47 challenger Exp $

module DPL_CYK 

( accepted, accepteds )

where

-- $Log: DPL_CYK.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:47  challenger
-- start
--
-- Revision 1.2  2001/11/29 13:41:20  autotool
-- CF_advanced: besserer parser, hrtere tests
--
-- Revision 1.1  2001/11/28 07:27:11  autotool
-- benutze DPL in CYK/CF_Chomsky
--



import Chomsky


-- eins der beiden auswhlen:

-- benutzt FiniteMap (besser fr hugs?)
-- import CYK_Tables

-- benutzt Arrays (auf jeden fall besser fr ghc -O)
import CYK_Arrays

-- end auswahl


import DPL_Set

import Ix

-- accepted :: Ix a => Chomsky a -> String -> Bool
accepted :: Chomsky Int -> String -> Bool
accepted ch w = 
    let c = ctable $ rules ch
	v = vtable $ rules ch
	top = value (ctable_lookup c) (vtable_lookup v) w 
    in	start ch `elementOf` top

-- accepteds :: Ix a => Chomsky a -> [ String ] -> [ (String, Bool) ]
accepteds :: Chomsky Int -> [ String ] -> [ (String, Bool) ]
accepteds ch ws = do
    let c = ctable $ rules ch
    let v = vtable $ rules ch
    (w, top) <- values (ctable_lookup c) (vtable_lookup v) 
	     $ filter (not . null) ws
    return (w, start ch `elementOf` top)



