module Overlap

where

import Monad (guard)

import Wort
import Grammatik

overlaps :: Grammatik -> [ String ]
-- wir schieben r2 unter r1
overlaps g = do
    lr1 @ (l1, r1) <- rules g
    lr2 @ (l2, r2) <- rules g
    d <- [ if lr1 == lr2 then 1 else 0 .. length r1 ]
    let c = min (length r1 - d) (length r2)
    let (r1v, r1mh) = splitAt d $ r1
    let (r1m, r1h) = splitAt c $ r1mh 
    let (r2m, r2h) = splitAt c $ r2
    guard $ r1m == r2m
    let pre = r1v
    let post = r1h ++ r2h -- einer von beiden ist leer
    return $ show $ error "keine Ahnung"


