module Machine 

( Machine (..)
)

where

import Set
import FiniteMap
import Table

instance Show a => Show (Set a) where
   showsPrec p = showsPrec p . setToList

data Machine q s s' p = 
     Machine { start :: q
	     , final :: Set q
	     , transitions :: Table q s s' p
	     }




