module NFA 


( nfa
, NFA

, module Set 
, module FiniteMap
, module Machine
)

where

import Set
import FiniteMap

import Tape
import Machine
import Table

type NFA q s = FiniteMap (q, s) [q]

nfa :: NFA q s -> Table q s s Index
nfa = mapFM ( \ (q, s) qs' -> map ( \ q' -> (q', s, right) ) qs' )







