module NFATest where

import NFA
import NFAExample

import Memory
import Tape
import Pointed
import Empty
import Execute

input = "aabbaabaa"

mem :: Tape Char
mem = foldr ( \ (i, c) m -> put m (Index i) c ) empty 
    $ zip [ 0.. ] input

test :: IO ()
test = print
     $ finals ex ( mem ) (length input)

