module PCP where

import Report
import Right
import Auswertung
import FiniteMap 

type PCP = FiniteMap Char (String, String)

morph :: FiniteMap Char String -> String -> String
morph fm cs = do 
      c <- cs
      lookupWithDefaultFM fm (error "PCP.morph") c

check ::  [ (String, String) ] -> String -> IO String
check ous student = do
    let pcp = listToFM $ zip ['A' .. ] $ ous

    putStrLn $ unlines 
	     [ "Ich bin der automatische Korrektor"
	     , "fr das PCP " ++ show pcp
	     , ""
	     , "Ihre Lsung lautet " ++ student
	     ]

    mu ( if null student
	  then Left "das Lsungswort darf nicht leer sein"
	  else Right "" ) $ do

    let oben  = morph (mapFM ( \ k (o, u) -> o ) pcp) student
    let unten = morph (mapFM ( \ k (o, u) -> u ) pcp) student

    putStrLn $ "das obere  Bild ist " ++ oben 
    putStrLn $ "das untere Bild ist " ++ unten
    putStrLn $ "\n"

    mu ( if oben /= unten
	  then Left  "die beiden Wrter stimmen nicht berein"
	  else Right "die beiden Wrter stimmen berein" ) $ do

    right

