-- $Header: /home/joe/scratch/challenger/autotool/pump/pro/Negativ_Simple.hs,v 1.1.1.1 2002/05/24 10:46:48 challenger Exp $

module Negativ

( negativ )

where

-- $Log: Negativ_Simple.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.1  2001/12/05 21:13:33  autotool
-- pump/*/* neu
--

import Pump
import Language
import ToDoc
import Size
import Monad (guard)
import Right
import Wrong
import Auswertung


negativ :: Language -> Pump -> IO String
negativ l p @ Nein {} = do
    putStrLn $ unlines
	     [ "Guten Tag. Sie mchten nachweisen, da die Sprache " ++ show l
	     , "die Pump-Eigenschaft fr kontextfreie Sprachen NICHT erfllt."
	     , ""
	     , "Sie behaupten, zu jeder Zahl n > 0 gibt es ein Wort  w  mit  |w| >= n,"
	     , "so da zu jeder gltigen Zerlegung  w = u v x y z  ein  i  existiert,"
	     , "fr das   u v^i x y^i z  nicht in " ++ show l ++ " ist."
	     ]
    let ns = [ 1 .. 10 ]
    let reports = take 3 $ do n <- ns; report l p n
    if null reports
	    then do 
	       putStrLn $ unlines
			[ "OK, Ihr Programm hat in jedem Fall ein passendes i gefunden"
			, "Das beweist, da " ++ show l ++ " nicht kontextfrei ist"
			, "--- oder Sie hatten Glck beim Wrfeln der Testflle."
			]
	       right
	    else do 
	       putStrLn $ unlines reports
	       wrong



    
report l neg @ Nein {} n = 
    let w = wort neg n
	prefix = "Ich whle  n = " ++ show n ++ ", "
	       ++ "Sie whlen  w = " ++ show w ++ "."
	       ++ "\n"
    in	map (prefix ++) $ 
	   [ "das  w  ist aber gar nicht in " ++ show l | not (contains l w) ]
	++ [ "es gilt aber nicht |w| >= n"            | length w < n       ]
	++ do 
	      z <- zerlegungen w n
	      let i = expo neg n z
	      let w' = aufpump z i
	      let prefix = "Ich whle " ++ show z ++ ", Sie whlen i = " ++ show i
	      map (prefix ++) $
		     [ "es gilt aber nicht i >= 0" | i < 0 ]
		  ++ [ "es ist aber doch  u v^i x y^i z in " ++ show l
		         |  contains l w' ]
