module LoesungTM1 where

import Turing

data Z = Q1 | Q2 | Q3 | Q4 | Q5 
     deriving (Eq, Ord, Show)

student :: Turing Char Z
student = Turing 
        { eingabealphabet = mkSet "A"
        , leerzeichen     = '#'
        , arbeitsalphabet = mkSet "#AB01"
        , zustandsmenge  = mkSet [ Q1, Q2, Q3, Q4, Q5 ]
        , tafel = t
        , startzustand   = Q4
        , endzustandsmenge = mkSet [ Q5 ]
        }


t = listToFM
      [ ( ('0', Q1), mkSet [ ( '0', Q1, L ) ] )
      , ( ('1', Q1), mkSet [ ( '1', Q1, L ) ] )
      , ( ('B', Q1), mkSet [ ( 'B', Q1, L ) ] )
      , ( ('#', Q1), mkSet [ ( '0', Q3, R ) ] )
      , ( ('A', Q1), mkSet [ ( 'B', Q2, L ) ] )

      , ( ('0', Q2), mkSet [ ( '0', Q2, L ) ] )
      , ( ('1', Q2), mkSet [ ( '1', Q2, L ) ] )
      , ( ('B', Q2), mkSet [ ( 'B', Q2, L ) ] )
      , ( ('A', Q2), mkSet [ ( 'A', Q1, L ) ] )
      , ( ('#', Q2), mkSet [ ( '1', Q3, R ) ] )

      , ( ('0', Q3), mkSet [ ( '0', Q3, R ) ] )
      , ( ('1', Q3), mkSet [ ( '1', Q3, R ) ] )
      , ( ('B', Q3), mkSet [ ( 'B', Q3, R ) ] )
      , ( ('A', Q3), mkSet [ ( 'A', Q4, R ) ] )

      , ( ('A', Q4), mkSet [ ( 'A', Q4, R ) ] )
      , ( ('B', Q4), mkSet [ ( 'B', Q4, R ) ] )
      , ( ('#', Q4), mkSet [ ( '#', Q1, L ) ] )
      
      , ( ('#', Q3), mkSet [ ( '#', Q5, L ) ] )
      ]



