module LoesungTM41 where

import Turing

data Z = Q1 | Q2 
     deriving (Eq, Ord, Show)

student :: Turing Char Z
student = Turing 
        { eingabealphabet = mkSet "A"
        , leerzeichen     = '#'
        , arbeitsalphabet = mkSet "#A"
        , zustandsmenge  = mkSet [ Q1, Q2 ]
        , tafel = t
        , startzustand   = Q1
        , endzustandsmenge = mkSet [ Q2 ]
        }


t = listToFM
      [ ( ('A', Q1), mkSet [ ( 'A', Q1, R ) ] )
      , ( ('#', Q1), mkSet [ ( '#', Q2, R ) ] )
      ]


