
#include <stdlib.h>
#include <stdio.h>

#define KN 30

int depth=0, buf[KN+2], e[KN][KN];

#define R(k,S)     for (k=0;k<S;k++)
#define W(k,v)     buf[k]=v
#define SET(i,j,v) e[i-1][j-1]=e[j-1][i-1]=v

void findHam () {
  int i, j, l, already_used;
  //printf("[%2d] ",depth); R(i,KN) printf("%d, ",buf[i]); printf("\n");

  if (depth+1==KN && e[buf[depth]-1][0])
    { printf("["); R(i,KN-1) printf("%d,",buf[i]); printf("%d]\n",buf[KN-1]); return; }

  R(j,KN) if (e[buf[depth]-1][j]) {
    //printf("...%d %d\n", buf[depth],j+1);
    already_used = 0; R(l,depth+1) already_used += (buf[l]==j+1)?1:0; 
    if (!already_used) { W(++depth,j+1); findHam(); depth--; }
  }
}

int main () {
  int i, j;

  R(i,KN) R(j,KN) SET(i,j,0);

  // ham 1
  SET(6,3,1);  SET(7,4,1);  SET(8,1,1);  SET(8,5,1);  SET(9,2,1);  SET(10,3,1);
  SET(11,2,1); SET(11,8,1); SET(12,1,1); SET(12,3,1); SET(12,9,1); SET(13,2,1);
  SET(13,4,1); SET(13,6,1); SET(13,10,1);SET(14,3,1); SET(14,5,1); SET(14,7,1);
  SET(15,4,1); SET(15,8,1); SET(16,7,1); SET(16,13,1);SET(17,6,1); SET(17,8,1);
  SET(17,14,1);SET(18,7,1); SET(18,9,1); SET(18,11,1);SET(18,15,1);SET(19,8,1);
  SET(19,10,1);SET(19,12,1);SET(20,9,1); SET(20,13,1);SET(21,12,1);SET(21,18,1);
  SET(22,11,1);SET(22,13,1);SET(22,19,1);SET(23,12,1);SET(23,14,1);SET(23,16,1);
  SET(23,20,1);SET(24,13,1);SET(24,15,1);SET(24,17,1);SET(25,14,1);SET(25,18,1);
  SET(26,17,1);SET(26,23,1);SET(27,16,1);SET(27,18,1);SET(27,24,1);SET(28,17,1);
  SET(28,19,1);SET(28,21,1);SET(28,25,1);SET(29,18,1);SET(29,20,1);SET(29,22,1);
  SET(30,19,1);SET(30,23,1);

  //  R(i,KN) { R(j,KN) printf("%d ", e[i][j]); printf("\n"); };

  R(i,KN) W(i,0); W(0,1); findHam(); return 0;
}

/*
  SET(1,2,1);SET(2,3,1);SET(3,4,1);SET(4,5,1);SET(5,1,1);

  // ham2:
  SET(5,3,1);  SET(6,4,1);  SET(7,1,1);  SET(8,2,1);  SET(9,3,1);  SET(10,2,1);
  SET(10,7,1); SET(11,1,1); SET(11,3,1); SET(11,8,1); SET(12,2,1); SET(12,4,1);
  SET(12,5,1); SET(12,9,1); SET(13,3,1); SET(13,6,1); SET(14,4,1); SET(14,7,1);
  SET(15,6,1); SET(15,12,1);SET(16,5,1); SET(16,7,1); SET(16,13,1);SET(17,6,1);
  SET(17,8,1); SET(17,10,1);SET(17,14,1);SET(18,7,1); SET(18,9,1); SET(18,11,1);
  SET(19,8,1); SET(19,12,1);SET(20,11,1);SET(20,17,1);SET(21,10,1);SET(21,12,1);
  SET(21,18,1);SET(22,11,1);SET(22,13,1);SET(22,15,1);SET(22,19,1);SET(23,12,1);
  SET(23,14,1);SET(23,16,1);SET(24,13,1);SET(24,17,1);SET(25,16,1);SET(25,22,1);
  SET(26,15,1);SET(26,17,1);SET(26,23,1);SET(27,16,1);SET(27,18,1);SET(27,20,1);
  SET(27,24,1);SET(28,17,1);SET(28,19,1);SET(28,21,1);
*/
