module Bild.Doc where

import Bild.Type
import Bild.Ops

import ToDoc

instance Show [s] => ToDoc ( Bild s ) where
    toDoc b 
        | ist_leer b = text "<leer>"
	| otherwise  = vcat $ map (text . show) $ inhalt b

{-
-- warum geht das nicht?
instance ToDoc ( Bild Char ) where
    toDoc b = vcat $ map text $ inhalt b
-}

instance Show [s]  => 
    Show ( Bild s ) where show = render . toDoc

splits :: Int -> [a] -> [[a]]
splits d [] = []
splits d xs = let (pre, post) = splitAt d xs
	      in pre : splits d post

instance ToDoc [ Bild Char ] where
    toDoc bs = brackets $ vcat $ punctuate comma $ do
          line <- splits 5 bs
	  let commas [] = leer; commas [x] = x
	      commas (x : xs) = glues [ x, bild [","], commas xs ]
	  return $ vcat $ map text $ inhalt $ tiefer 1 $ commas line

instance Show [ Bild Char ] where show = render . toDoc

    



