module Bild.Drei where

import Bild
import Language

import Random
import Set
import ToDoc

drei :: Language Char (Bild Char)
drei = Language 
     { name = "DREI"
     , definition = text "{ b : b in {0,1}**, breit (b)=3 }"
     , alphabet     = mkSet "01"
     , contains = \ b -> ist_leer b || 3 == breit b 
     , sample = \ c n -> sequence $ do
         n' <- [ n .. n + c - 1 ]
	 return $ irgendein (3, n') "01"
     , anti_sample = anti drei
     }

