module Fourway.Bewegung where

import Bild.Position
import ToDoc

data Bewegung = L | R | U | D
     deriving (Eq, Show, Ord)

instance ToDoc Bewegung where
    toDoc = text . show

move :: Position -> Bewegung -> Position
move (x,y) L = (x-1,y)
move (x,y) R = (x+1,y)
move (x,y) U = (x,y-1)
move (x,y) D = (x,y+1)
