module RX.Klammer 

( module RX.Klammer
, module ToDoc
)

where

import ToDoc

class Klammer a where
      -- like showsPrec
      klammer :: a -> Int -> Doc

binary :: Klammer a 
       => Int -> String -> a -> a -> Int -> Doc
-- p: eigene Przedenz
-- q: Przedenz des Aufrufenden
binary p op l r q =
    ( if p < q then parens else id )
    ( klammer l p <+> text op <+> klammer r p )

binary0 :: Klammer a 
       => Int -> a -> a -> Int -> Doc
-- fr .| : weglassen
binary0 p l r q =
    ( if p < q then parens else id )
    ( klammer l p <+> klammer r p )

binary' :: Klammer a 
       => Int -> String -> a -> a -> Int -> Doc
-- fr Minus: rechts hhere Przedenz
binary' p op l r q =
    ( if p < q then parens else id )
    ( klammer l p <+> text op <+> klammer r (p+1) )

postfix :: Klammer a
	=> Int -> String -> a -> Int -> Doc
postfix p op l q =
    ( if p < q then parens else id )
    ( klammer l p <> text op )


