-- $Header: /home/joe/scratch/challenger/autotool/twodim/RX/MyTokens.hs,v 1.1.1.1 2002/05/24 10:47:03 challenger Exp $

module RX.MyTokens where

import Parsec
import ParsecLanguage
import qualified ParsecToken as P

me            = P.makeTokenParser meDef

lexeme          = P.lexeme me
parens          = P.parens me    
braces          = P.braces me    
semiSep         = P.semiSep me    
semiSep1        = P.semiSep1 me    
commaSep        = P.commaSep me    
commaSep1       = P.commaSep1 me    
whiteSpace      = P.whiteSpace me    
symbol          = P.symbol me    
identifier      = P.identifier me    
reserved        = P.reserved me    
reservedOp      = P.reservedOp me    
natural         = P.natural me    

meDef
    = haskellStyle
        { identStart        = letter
        , identLetter       = letter
        , opStart           = oneOf "=.-+^&;"
        , opLetter          = oneOf "=|.*-+^&;"
        , reservedOpNames   = [ "+", "-", "&"
			      , ".-"
			      , "^*|" , "^*-", "^**"
			      , "=", ";" 
			      ]
        , reservedNames     = [ "let" ] 
        }

