module Solution.Squares where

import Problem.Squares

import Fourway

student :: Fourway Char Integer
student = Fourway { alphabet = mkSet "01"
	 , randzeichen = '#'
	 , existenziell = mkSet [ 0 .. 3 ]

	 -- weil 4 universell ist und keine Nachfolger hat, 
	 -- verhlt er sich wie ein akzeptierender Endzustand
	 , universell = mkSet [ 4 ] 

	 , startet = 0
	 , tafel = t
	 }

t :: FiniteMap ( Integer, Char ) ( Set (Integer, Bewegung) )
t = listToFM
      [ ( (0, '0'), unitSet (1, D) )
      , ( (0, '1'), unitSet (1, D) )
      , ( (1, '0'), unitSet (0, R) )
      , ( (1, '1'), unitSet (0, R) )
      , ( (1, '#'), unitSet (2, U) )
      , ( (2, '0'), unitSet (3, R) )
      , ( (2, '1'), unitSet (3, R) )
      , ( (3, '#'), unitSet (4, L) )
      ]

