-- $Header: /home/joe/scratch/challenger/autotool/util/Simple_Schichten.hs,v 1.1.1.1 2002/05/24 10:46:48 challenger Exp $

module Simple_Schichten

-- nur Listen
-- Prfung auf Duplikate nur innerhalb einer Schicht
-- damit ist es eine lazy Liste von lazy Listen

( schichten 
, schichten'
)

-- $Log: Simple_Schichten.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.2  2001/11/26 13:55:58  autotool
-- stark vereinfachte Anzeige von Ableitungen
--
-- Revision 1.1  2001/11/26 13:27:44  autotool
-- neu
--

where

import Set
import List (nub)

schichten :: Ord a => (a -> Set a) -> a -> [ [a] ]
schichten f x0 = schichten' f [ x0 ]

schichten' :: Ord a => (a -> Set a) -> [a] -> [ [a] ]
schichten' f xs = sch f undefined xs

sch f schon jetzt =
    if null jetzt 
    then [] 
    else let alt = undefined -- schon `union` jetzt
	     next = nub $ concat [ setToList $ f w | w <- jetzt ]
	     neu  = next -- `minusSet` alt
	 in  jetzt : sch f alt neu

