-- $Header: /home/joe/scratch/challenger/autotool/util/Size.hs,v 1.2 2002/07/02 16:18:32 joe Exp $

module Size where

import Set
import FiniteMap

class Size a where size :: a -> Int

instance Size (Set a) where 
    size = cardinality

instance Size b => Size (FiniteMap a b) where
    size = sum . map size . eltsFM 

instance Size a => Size [a] where
    size = sum . map size
