-- $Header: /home/joe/scratch/challenger/autotool/util/Strip.hs,v 1.1.1.1 2002/05/24 10:46:48 challenger Exp $

module Strip 

( strip )

where

-- $Log: Strip.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.1  2001/11/29 09:00:36  autotool
-- neu
--

lexwords line = 
    case  lexes line of
	  [ foo ] -> foo
	  sonst -> error "lexwords"

lexes "" = [[]]
lexes cs = do
      ( this, that) <- lex cs
      rest <- lexes that
      return $ this : rest

-- kommentare wegschneiden
weed = takeWhile ( /= "--" )

-- imports und typdecls ignorieren
extract (ws : wss) = 
    case  ws of
	 ( "import" : rest ) -> extract wss
	 ( "student" : "::" : rest ) -> extract wss
	 ( "student" : "=" : rest ) -> 
	     unwords $ rest ++ concat wss
	 sonst -> extract wss
extract [] = []

strip = extract . map ( weed . lexwords ) . lines 

