module Trace 

( Trace, trace, traced
, put, get
)

where

import State

type Trace c a = State [ String ] c a

trace :: String -> Trace c ()
trace msg = write  ( msg : )

traced :: Trace c a -> ( [ String ], c, a )
traced m = let ( f, c, a ) = run m
	   in	( f [] , c, a )


