module Aufgabe56 where

import NPDA
import NPDATest

import Wort
import Random
import List (inits)

bal w = 
    let op = length $ filter (== '(') $ w
	cl = length $ filter (== ')') $ w
    in	op - cl

balanced :: Int -> IO String
balanced h = if 0 == h then return "" else do
    p <- randomRIO (0, h - 1)
    u <- balanced p; v <- balanced (h - p - 1)
    t <- randomIO 
    return $ if t then "(" ++ u ++ ")" ++ v 
		  else ")" ++ u ++ "(" ++ v 

--------------------------------------------------------------------

pos = do
    let fixed = [ "", "()", "(())", "()()" ]
    random <- sequence $ take 10 $ repeat 
	   $ do h <- randomRIO (2, 10); yes h
    return $ random ++ fixed

yes :: Int -> IO String
yes h = if 0 == h then return "" else do
    p <- randomRIO (0, h - 1)
    u <- yes p; v <- yes (h - p - 1)
    return $ "(" ++ u ++ ")" ++ v

--------------------------------------------------------------------

neg = do
    let fixed = [ "(", ")", ")(" ]
    none <- sequence $ take 10 $ repeat $ no 
    nearly <- sequence $ take 10 $ repeat $ near
    return $ nearly ++ fixed ++ none


no = do
    s <- randomRIO (2, 15)
    w <- someIO "()" s
    if 0 /= bal w 
       then return w 
       else no

near = do
    s <- randomRIO (2, 10)
    w <- balanced s
    if or $ do h <- inits w; return $ bal h < 0
       then return w
       else near

--------------------------------------------------------------------

bewerte student = do
    putStrLn $ unlines
	     [ "Ich bin der automatische Korrektor fr Aufgabe V.6."
	     , ""
	     , "Die Sprache der korrekten Klammerausdrcke"
	     , "soll durch einen Kellerautomaten durch Endzustnde akzeptiert werden"
	     , ""
	     , "Siehe auch http://www.informatik.uni-leipzig.de/~joe/edu/ws00/auspra/autotool/pda.html"
	     , ""
	     ]
    p <- pos
    n <- neg
    testNPDA akzeptierend_mit_endzustand p n student
