import Prelude hiding ( Functor, fmap )

class Functor c where
    fmap :: (a -> b) -> (c a -> c b)
    fmap2 :: (a -> b) -> (c a -> c b)

-- VORSICHT: es folgt eine FALSCHE Instanz
-- genauer: nur das Axiom T ist erfllt
-- instance Functor [] where
--   fmap f xs = [ f x | x <- reverse xs ]

-- jetzt machen wir es mal richtig
--instance Functor [] where
--  fmap2 = map
-- so geht es am krzesten

-- jetzt stimmen die Axiome T unc C, dafr aber nicht I
-- instance Functor [] where
--   fmap f [] = []
--   fmap f (x : xs) = [f x]
-- das gab es schon in der Vorlesung

-- als HA war nun noch etwas zu konstruieren, das T und I, aber nicht
-- C erfllt
-- instance Functor [] where
--   fmap f [] = []
--   fmap f (x:xs) = f x : fmap f xs
-- so ist das leider nur die Originalvariante...

-- zweite HA: fmap durch return und >>= definieren
-- instance Functor [] where
--   fmap f xs = xs >>= return.f -- die Nacheinanderausfhrung von
                                 -- return und f wird komponentenweise
                                 -- auf die Liste angewandt, dann wieder
                                 -- zu einer Ergebnisliste zusammen-
                                 -- gefgt 
-- funktioniert !!!
