module NoPal where

import Set
import Grammatik
import Vergleiche
import Ableitung
import Monad (guard)
import Wort
import Typen

ziel top = mkSet $ do
    h <- [1 .. top]
    w <- alle "ab" h
    guard $ w /= reverse w
    return w


bewerte :: Grammatik -> IO ()
bewerte g = do
    let schranke = 8
    case typ2 g of
	 Left msg -> do
	       putStrLn msg
	       putStrLn "\nIch rechne trotzdem weiter"
	       vergleiche schranke (ziel schranke) (schranke + 3) g
	       putStrLn "\nWie gesagt, die Grammatik sollte aber kontextfrei sein."
	 Right msg -> do
	       putStrLn msg
	       vergleiche schranke (ziel schranke) (schranke + 3) g


student = Grammatik
	{ terminale = "ab"
	, nichtterminale = "NE"
	, startsymbol = 'N'
	, regeln = [ ("N", "aEb"), ("N", "bEa")
		   , ("N", "aNa"), ("N", "bNb")
		   , ("E", ""), ("E", "aE"), ("E", "bE")
		   ]
	}




