-- $Header: /home/joe/scratch/challenger/autotool/ws01/aufgaben/L21common.hs,v 1.1.1.1 2002/05/24 10:46:49 challenger Exp $

module L21common where

import Exp
import qualified Env
import Syntax
import Sanity
import Inter
import Set
import Vergleiche
import Size
import Auswertung

common :: String -> Exp -> Exp -> IO String
common msg goal exp = do
    putStrLn $ "Ich bin das Korrekturprogramm fr Aufgabe " ++ msg

    putStrLn $ "\nSie haben diesen regulren Ausdruck S eingesandt:"
    print exp

    let s = size exp
    putStrLn $ "\nDieser Ausdruck enthlt " ++ show s ++ " Zeichen und Operatoren."
    muss ( if s < 100 then Right "" 
	   else Left  "Das sind mir zu viele. Gre 100 gengt!"
	 ) $ do

      let ok = "OK # Size: " ++ show s

      let alpha = "ab"
      let std = std_sigma alpha

      einfach exp 
         $ sane (mkSet alpha) (Env.keys std) exp
         $ vergleiche ok (inter std goal) (inter std exp)




