-- $Header: /home/joe/scratch/challenger/autotool/ws01/aufgaben/Schnitt.hs,v 1.2 2002/05/24 11:32:31 challenger Exp $

module Schnitt where

import ToDoc
import Size
import NFA
import Ops
import Right
import Restrict
import Auswertung

bewerte :: (ToDoc a, ToDoc [a], ToDoc (NFA a), Ord a) 
      => String -> [ NFA a ] -> IO String
bewerte mat = check "AS3.3" 10

check ::  (ToDoc a, ToDoc [a], ToDoc (NFA a), Ord a) 
      => String -> Int -> [ NFA a ] -> IO String
check msg bound student = do
    putStrLn $ "Ich bin das Korrekturprogramm fr Aufgabe " ++ msg

    putStrLn $ "\nSie haben diese Liste von Automaten eingesandt:"
    putStrLn $ render $ toDoc student

    let s = sum $ map size $ student
    putStrLn $ "\nDas sind insgesamt " ++ show s ++ " Zustnde."

    muss ( und [ restrict_states a | a <- student ] ) $
      muss ( if s <= bound then Right "" else Left 
            ( "Das sind zu viele. Erlaubt waren nur " ++ show bound ) ) $ do

        let a = foldr1 ( \ x y -> normalize $ intersection x y ) 
              $ map normalize student
        let ws = accepted a
      
        muss ( if null ws then Left "Der Durchschnitt der akzeptierten Sprachen ist leer." else Right "" ) $ do
          
          putStrLn $ "Der Durchschnitt der akzeptierten Sprachen enthlt unter anderem diese Wrter:"
          putz $ ws
          let l = length (head ws)
          putStrLn $ "Das krzeste dieser Wrter hat die Lnge " ++ show l

	  muss ( if l <= bound then Left ( "Sie sollte aber grer als "
	          ++ show bound ++ " sein." ) else Right "" ) $ do

              right_with $ "OK # Size: " ++ show l




