
import Set
import NFA

xys :: [ (Int, Int) ]
xys =  [ (x,y) | x <- [0..2], y <- [0..2] ]

trim x = min x 2

student :: NFA Int
student = normalize NFA 
  { states = mkSet xys
  , starts = mkSet [ (0,0) ]
  , finals = 
	mkSet [ (x,y) | (x,y) <- xys , (x >= 2) == (y <= 1) ]
  , trans  = collect 
	(  [ ((x,y), 'a', (trim (x+1), y) ) | (x,y) <- xys ]
	++ [ ((x,y), 'b', (x, trim (y+1)) ) | (x,y) <- xys ]
	)
  }
