import NFA
import Set

student :: NFA Int
student = NFA 
	{ states = mkSet [1 .. 5 ]
	, starts = mkSet [1]
	, finals = mkSet [2, 3]
	, trans  = collect 
	      [ (1, 'a', 2), (2, 'a', 1)
	      , (1, 'b', 3), (2, 'b', 4) 
	      , (3, 'b', 4), (4, 'b', 3)
	      , (3, 'a', 5), (4, 'a', 5)
	      , (5, 'a', 5), (5, 'b', 5)
	      ] 
	}
